Add bootstrap scripts to repository to be versioned

This commit is contained in:
Marty Oehme 2019-03-06 13:06:44 +01:00
parent 9cbce930ce
commit 21b56671da
2 changed files with 267 additions and 0 deletions

View file

@ -0,0 +1,233 @@
#!/bin/sh
# Luke's Auto Rice Boostrapping Script (LARBS)
# by Luke Smith <luke@lukesmith.xyz>
# License: GNU GPLv3
### OPTIONS AND VARIABLES ###
while getopts ":a:r:p:h" o; do case "${o}" in
h) printf "Optional arguments for custom use:\\n -r: Dotfiles repository (local file or url)\\n -p: Dependencies and programs csv (local file or url)\\n -a: AUR helper (must have pacman-like syntax)\\n -h: Show this message\\n" && exit ;;
r) dotfilesrepo=${OPTARG} && git ls-remote "$dotfilesrepo" || exit ;;
p) progsfile=${OPTARG} ;;
a) aurhelper=${OPTARG} ;;
*) printf "Invalid option: -%s\\n" "$OPTARG" && exit ;;
esac done
# DEFAULTS:
[ -z "$dotfilesrepo" ] && dotfilesrepo="https://gitlab.com/marty-oehme/dotfiles.git"
[ -z "$progsfile" ] && progsfile="https://gitlab.com/marty-oehme/dotfiles/snippets/1828258/raw"
[ -z "$aurhelper" ] && aurhelper="yay"
### FUNCTIONS ###
error() { clear; printf "ERROR:\\n%s\\n" "$1"; exit;}
welcomemsg() { \
dialog --title "Welcome!" --msgbox "Welcome to Bootstrapping!\\n\\nThis script will automatically install necessary arch setup and a base package selection." 10 60
}
getuserandpass() { \
# Prompts user for new username an password.
name=$(dialog --inputbox "First, please enter a name for the user account." 10 60 3>&1 1>&2 2>&3 3>&1) || exit
while ! echo "$name" | grep "^[a-z_][a-z0-9_-]*$" >/dev/null 2>&1; do
name=$(dialog --no-cancel --inputbox "Username not valid. Give a username beginning with a letter, with only lowercase letters, - or _." 10 60 3>&1 1>&2 2>&3 3>&1)
done
pass1=$(dialog --no-cancel --passwordbox "Enter a password for that user." 10 60 3>&1 1>&2 2>&3 3>&1)
pass2=$(dialog --no-cancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
while ! [ "$pass1" = "$pass2" ]; do
unset pass2
pass1=$(dialog --no-cancel --passwordbox "Passwords do not match.\\n\\nEnter password again." 10 60 3>&1 1>&2 2>&3 3>&1)
pass2=$(dialog --no-cancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
done ;}
usercheck() { \
! (id -u "$name" >/dev/null) 2>&1 ||
dialog --colors --title "WARNING!" --yes-label "CONTINUE" --no-label "No wait..." --yesno "The user \`$name\` already exists on this system. LARBS can install for a user already existing, but it will \\Zboverwrite\\Zn any conflicting settings/dotfiles on the user account.\\n\\nLARBS will \\Zbnot\\Zn overwrite your user files, documents, videos, etc., so don't worry about that, but only click <CONTINUE> if you don't mind your settings being overwritten.\\n\\nNote also that LARBS will change $name's password to the one you just gave." 14 70
}
preinstallmsg() { \
dialog --title "Let's get this party started!" --yes-label "Let's go!" --no-label "No, nevermind!" --yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || { clear; exit; }
}
adduserandpass() { \
# Adds user `$name` with password $pass1.
dialog --infobox "Adding user \"$name\"..." 4 50
useradd -m -g wheel -s /bin/bash "$name" >/dev/null 2>&1 ||
usermod -a -G wheel "$name" && mkdir -p /home/"$name" && chown "$name":wheel /home/"$name"
echo "$name:$pass1" | chpasswd
unset pass1 pass2 ;}
refreshkeys() { \
dialog --infobox "Refreshing Arch Keyring..." 4 40
pacman --noconfirm -Sy archlinux-keyring >/dev/null 2>&1
}
newperms() { # Set special sudoers settings for install (or after).
sed -i "/#LARBS/d" /etc/sudoers
echo "$* #LARBS" >> /etc/sudoers ;}
manualinstall() { # Installs $1 manually if not installed. Used only for AUR helper here.
[ -f "/usr/bin/$1" ] || (
dialog --infobox "Installing \"$1\", an AUR helper..." 4 50
cd /tmp || exit
rm -rf /tmp/"$1"*
curl -sO https://aur.archlinux.org/cgit/aur.git/snapshot/"$1".tar.gz &&
sudo -u "$name" tar -xvf "$1".tar.gz >/dev/null 2>&1 &&
cd "$1" &&
sudo -u "$name" makepkg --noconfirm -si >/dev/null 2>&1
cd /tmp || return) ;}
maininstall() { # Installs all needed programs from main repo.
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total). $1 $2" 5 70
pacman --noconfirm --needed -S "$1" >/dev/null 2>&1
}
gitmakeinstall() {
dir=$(mktemp -d)
dialog --title "LARBS Installation" --infobox "Installing \`$(basename "$1")\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 5 70
git clone --depth 1 "$1" "$dir" >/dev/null 2>&1
cd "$dir" || exit
make >/dev/null 2>&1
make install >/dev/null 2>&1
cd /tmp || return ;}
aurinstall() { \
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total) from the AUR. $1 $2" 5 70
echo "$aurinstalled" | grep "^$1$" >/dev/null 2>&1 && return
sudo -u "$name" $aurhelper -S --noconfirm "$1" >/dev/null 2>&1
}
installationloop() { \
([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) || curl -Ls "$progsfile" | sed '/^#/d' > /tmp/progs.csv
total=$(wc -l < /tmp/progs.csv)
aurinstalled=$(pacman -Qm | awk '{print $1}')
while IFS=, read -r tag program comment; do
n=$((n+1))
echo "$comment" | grep "^\".*\"$" >/dev/null 2>&1 && comment="$(echo "$comment" | sed "s/\(^\"\|\"$\)//g")"
case "$tag" in
"") maininstall "$program" "$comment" ;;
"A") aurinstall "$program" "$comment" ;;
"G") gitmakeinstall "$program" "$comment" ;;
esac
done < /tmp/progs.csv ;}
dotfiles() { \
gpath=$1
shift
/usr/bin/git --git-dir=$gpath/.dotfiles --work-tree=$gpath $@
}
putgitrepo() { # Downlods a gitrepo $1 and places the files in $2 only overwriting conflicts
dialog --infobox "Downloading and installing config files..." 4 60
dir=$(mktemp -d)
dfdir="$2"
[ ! -d "$2" ] && mkdir -p "$2" && chown -R "$name:wheel" "$2"
chown -R "$name:wheel" "$dir"
sudo -u "$name" git clone --bare "$1" "$dir/gitrepo" >/dev/null 2>&1 &&
sudo -u "$name" cp -rfT "$dir/gitrepo" $dfdir/.dotfiles
dotfiles $dfdir checkout
if [ $? = 0 ]; then
echo "Checked out dotfiles.";
else
echo "Backing up existing dotfiles.";
mkdir -p $2/.dotfiles-backup
dotfiles $dfdir checkout 2>&1 | egrep "\s+\." | awk {'print $1'} | xargs -I{} mv {} $2/.dotfiles-backup/{}
fi;
dotfiles $dfdir checkout
dotfiles $dfdir config status.showUntrackedFiles no
}
serviceinit() { for service in "$@"; do
dialog --infobox "Enabling \"$service\"..." 4 40
systemctl enable "$service"
systemctl start "$service"
done ;}
systembeepoff() { dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
rmmod pcspkr
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf ;}
resetpulse() { dialog --infobox "Reseting Pulseaudio..." 4 50
killall pulseaudio
sudo -n "$name" pulseaudio --start ;}
finalize(){ \
dialog --infobox "Preparing welcome message..." 4 50
dialog --title "All done!" --msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command \"startx\" to start the graphical environment (it will start automatically in tty1).\\n\\n.t Luke" 12 80
}
### THE ACTUAL SCRIPT ###
### This is how everything happens in an intuitive format and order.
# Check if user is root on Arch distro. Install dialog.
pacman -Syu --noconfirm --needed dialog || error "Are you sure you're running this as the root user? Are you sure you're using an Arch-based distro? ;-) Are you sure you have an internet connection? Are you sure your Arch keyring is updated?"
# Welcome user.
welcomemsg || error "User exited."
# Get and verify username and password.
getuserandpass || error "User exited."
# Give warning if user already exists.
usercheck || error "User exited."
# Last chance for user to back out before install.
preinstallmsg || error "User exited."
### The rest of the script requires no user input.
adduserandpass || error "Error adding username and/or password."
# Refresh Arch keyrings.
refreshkeys || error "Error automatically refreshing Arch keyring. Consider doing so manually."
dialog --title "LARBS Installation" --infobox "Installing \`basedevel\` and \`git\` for installing other software." 5 70
pacman --noconfirm --needed -S base-devel git >/dev/null 2>&1
[ -f /etc/sudoers.pacnew ] && cp /etc/sudoers.pacnew /etc/sudoers # Just in case
# Allow user to run sudo without password. Since AUR programs must be installed
# in a fakeroot environment, this is required for all builds with AUR.
newperms "%wheel ALL=(ALL) NOPASSWD: ALL"
# Make pacman and yay colorful and adds eye candy on the progress bar because why not.
sed -i "s/^#Color/Color/g;/#VerbosePkgLists/a ILoveCandy" /etc/pacman.conf
# Use all cores for compilation.
sed -i "s/-j2/-j$(nproc)/;s/^#MAKEFLAGS/MAKEFLAGS/" /etc/makepkg.conf
manualinstall $aurhelper || error "Failed to install AUR helper."
# The command that does all the installing. Reads the progs.csv file and
# installs each needed program the way required. Be sure to run this only after
# the user has been created and has priviledges to run sudo without a password
# and all build dependencies are installed.
installationloop
# Install the dotfiles in the user's home directory
putgitrepo "$dotfilesrepo" "/home/$name"
rm "/home/$name/README.md"
# Pulseaudio, if/when initially installed, often needs a restart to work immediately.
[ -f /usr/bin/pulseaudio ] && resetpulse
# Install vim `plugged` plugins.
dialog --infobox "Installing (neo)vim plugins..." 4 50
(sleep 30 && killall nvim) &
sudo -u "$name" nvim -E -c "PlugUpdate|visual|q|q" >/dev/null 2>&1
# Enable services here.
serviceinit NetworkManager cronie
# Most important command! Get rid of the beep!
systembeepoff
# This line, overwriting the `newperms` command above will allow the user to run
# serveral important commands, `shutdown`, `reboot`, updating, etc. without a password.
newperms "%wheel ALL=(ALL) ALL #LARBS
%wheel ALL=(ALL) NOPASSWD: /usr/bin/shutdown,/usr/bin/reboot,/usr/bin/systemctl suspend,/usr/bin/wifi-menu,/usr/bin/mount,/usr/bin/umount,/usr/bin/pacman -Syu,/usr/bin/pacman -Syyu,/usr/bin/packer -Syu,/usr/bin/packer -Syyu,/usr/bin/systemctl restart NetworkManager,/usr/bin/rc-service NetworkManager restart,/usr/bin/pacman -Syyu --noconfirm,/usr/bin/loadkeys,/usr/bin/yay,/usr/bin/pacman -Syyuw --noconfirm"
# Last message! Install complete!
finalize
clear

View file

@ -0,0 +1,34 @@
#TAG,NAME IN REPO (or git url),PURPOSE (should be a verb phrase to sound right while installing)
,i3-gaps,"is the main graphical user interface and window manager."
,i3blocks,"is the status bar block provider for i3."
,xorg-server,"is the graphical server."
,xorg-xinit,"starts the graphical server."
,ranger,"is an extensive terminal file manager that everyone likes."
,dosfstools,"allows your computer to access dos-like filesystems."
,neovim,"a tidier vim with some useful features"
,i3blocks,"is the status bar."
,i3lock,"is the screen lock."
,mpv,"is the patrician's choice video/gif player."
,networkmanager,"does exactly what it sounds like."
,ntfs-3g,"allows accessing NTFS partitions."
,pulseaudio,"is the audio system (>inb4 bloat)."
,pulseaudio-alsa,"is an audio interface with ALSA."
,pulsemixer,"is an intuitive ncurses audio controller."
,tmux,"is a terminal multiplexer and the dropdown window in LARBS."
,unrar,"extracts rar's."
,unzip,"unzips zips."
,xclip,"allows for copying and pasting from the command line."
,xdotool,"provides window action utilities on the command line."
,youtube-dl,"can download any YouTube video (or playlist or channel) when given the link."
,atool,"manages and gives information about archives."
,fzf,"is a fuzzy finder tool."
,zsh,"is a shell alternative to bash."
A,nerd-fonts-fira-code,"is the mono-space font of choice, patched with embedded icon symbols."
,qutebrowser,"is a keyboard focused browser with vim-keys enabled."
,mopidy,"is an extensible music server written in python."
A,mopidy-spotify,"is a mopidy extension to play music from spotify."
A,mopidy-scrobbler,"is a mopidy extension to scrobble to last.fm."
A,mopidy-spotify-tunigo,"is a mopidy extension to enable spotify browsing."
A,mopidy-podcast,"is a mopidy extension to search and browse podcasts."
,rxvt-unicode,"is a simple and efficient terminal emulator."
1 #TAG NAME IN REPO (or git url) PURPOSE (should be a verb phrase to sound right while installing)
2 i3-gaps is the main graphical user interface and window manager.
3 i3blocks is the status bar block provider for i3.
4 xorg-server is the graphical server.
5 xorg-xinit starts the graphical server.
6 ranger is an extensive terminal file manager that everyone likes.
7 dosfstools allows your computer to access dos-like filesystems.
8 neovim a tidier vim with some useful features
9 i3blocks is the status bar.
10 i3lock is the screen lock.
11 mpv is the patrician's choice video/gif player.
12 networkmanager does exactly what it sounds like.
13 ntfs-3g allows accessing NTFS partitions.
14 pulseaudio is the audio system (>inb4 bloat).
15 pulseaudio-alsa is an audio interface with ALSA.
16 pulsemixer is an intuitive ncurses audio controller.
17 tmux is a terminal multiplexer and the dropdown window in LARBS.
18 unrar extracts rar's.
19 unzip unzips zips.
20 xclip allows for copying and pasting from the command line.
21 xdotool provides window action utilities on the command line.
22 youtube-dl can download any YouTube video (or playlist or channel) when given the link.
23 atool manages and gives information about archives.
24 fzf is a fuzzy finder tool.
25 zsh is a shell alternative to bash.
26 A nerd-fonts-fira-code is the mono-space font of choice, patched with embedded icon symbols.
27 qutebrowser is a keyboard focused browser with vim-keys enabled.
28 mopidy is an extensible music server written in python.
29 A mopidy-spotify is a mopidy extension to play music from spotify.
30 A mopidy-scrobbler is a mopidy extension to scrobble to last.fm.
31 A mopidy-spotify-tunigo is a mopidy extension to enable spotify browsing.
32 A mopidy-podcast is a mopidy extension to search and browse podcasts.
33 rxvt-unicode is a simple and efficient terminal emulator.